package at.fhooe.mc.magicwand.client.test;

import java.util.Vector;
import at.fhooe.mc.magicwand.client.exceptions.ParsingException;
import at.fhooe.mc.magicwand.client.poi.*;

/**
 * @class ParsingTest
 * @author Maria Neumayer
 * @brief Checks xml parser by making a xmlString with different POI
 */
public class ParsingTest {

    /**
     * @fn public static void main(String[] _args)
     * @brief main function to start test
     * @param _args start arguments
     */
    public static void main(String[] _args) {
        StringBuffer xmlString = new StringBuffer();
        xmlString.append("<?xml version=\"1.0\" encoding=\"UTF-8\"?>");
        xmlString.append("<magic-wand>");
        xmlString.append("<poi>");
        xmlString.append("<name>poi1</name>");
        xmlString.append("<description>poi1 test</description>");
        xmlString.append("<link>http://poi1</link>");
        xmlString.append("<category>poi1-category</category>");
        xmlString.append("<priority>1</priority>");
        xmlString.append("<distance>near</distance>");
        xmlString.append("</poi>");
        xmlString.append("<poi>");
        xmlString.append("<name>poi2</name>");
        xmlString.append("<description>poi2 test</description>");
        xmlString.append("<link>http://poi2</link>");
        xmlString.append("<category>poi2-category</category>");
        xmlString.append("<priority>2</priority>");
        xmlString.append("<distance>middle</distance>");
        xmlString.append("</poi>");
        xmlString.append("<poi>");
        xmlString.append("<name>poi3</name>");
        xmlString.append("<description>poi3 test</description>");
        xmlString.append("<link>http://poi3</link>");
        xmlString.append("<category>poi3-category</category>");
        xmlString.append("<priority>3</priority>");
        xmlString.append("<distance>far</distance>");
        xmlString.append("</poi>");
        xmlString.append("<poi>");
        xmlString.append("<name></name>");
        xmlString.append("<description>poi4 test</description>");
        xmlString.append("<link>http://poi4</link>");
        xmlString.append("<category>poi4-category</category>");
        xmlString.append("<priority>4</priority>");
        xmlString.append("<distance>far</distance>");
        xmlString.append("</poi>");
        xmlString.append("<poi>");
        xmlString.append("<name>poi5</name>");
        xmlString.append("<description>poi5 test</description>");
        xmlString.append("<link></link>");
        xmlString.append("<category>poi5-category</category>");
        xmlString.append("<priority>5</priority>");
        xmlString.append("<distance>far</distance>");
        xmlString.append("</poi>");
        xmlString.append("</magic-wand>");
        String xmlStr = xmlString.toString();
        XMLParser xml = new XMLParser();
        try {
            xml.parseXML(xmlStr);
        } catch (ParsingException _e) {
            _e.printStackTrace();
        }
        Vector poi = xml.getM_poiVector();
        for (int i = 0; i < poi.size(); i++) {
            ((POI) poi.elementAt(i)).print();
        }

    }
}