/*
========================================================================
 Name        : MagicWandServerContainer.h
 Author      : Manuela Vogler
 Copyright   : 
 Description : 
========================================================================
*/
#ifndef MAGICWANDSERVERCONTAINER_H
#define MAGICWANDSERVERCONTAINER_H

// [[[ begin generated region: do not modify [Generated Includes]
#include <coecntrl.h>		
// ]]] end generated region [Generated Includes]


// [[[ begin [Event Handler Includes]
// ]]] end [Event Handler Includes]

// [[[ begin generated region: do not modify [Generated Forward Declarations]
class MEikCommandObserver;		
class CEikLabel;
// ]]] end generated region [Generated Forward Declarations]

/**
 * @class	CMagicWandServerContainer MagicWandServerContainer.h
 * @brief Container class for MagicWandServerContainer
 */
class CMagicWandServerContainer : public CCoeControl
	{
public:
	// constructors and destructor
	CMagicWandServerContainer();
	static CMagicWandServerContainer* NewL( 
		const TRect& aRect, 
		const CCoeControl* aParent, 
		MEikCommandObserver* aCommandObserver );
	static CMagicWandServerContainer* NewLC( 
		const TRect& aRect, 
		const CCoeControl* aParent, 
		MEikCommandObserver* aCommandObserver );
	void ConstructL( 
		const TRect& aRect, 
		const CCoeControl* aParent, 
		MEikCommandObserver* aCommandObserver );
	virtual ~CMagicWandServerContainer();

public:
	// from base class CCoeControl
	TInt CountComponentControls() const;
	CCoeControl* ComponentControl( TInt aIndex ) const;
	TKeyResponse OfferKeyEventL( 
			const TKeyEvent& aKeyEvent, 
			TEventCode aType );
	void HandleResourceChange( TInt aType );
	
public:
	//public functions
	void SetLabelTextL(const TDesC& aText);
	void SetServerStarted(TBool aValue);
	TBool GetServerStarted ();
	
protected:
	// from base class CCoeControl
	void SizeChanged();

private:
	// from base class CCoeControl
	void Draw( const TRect& aRect ) const;

private:
	void InitializeControlsL();
	void LayoutControls();
	CCoeControl* iFocusControl;
	MEikCommandObserver* iCommandObserver;
	// [[[ begin generated region: do not modify [Generated Methods]
public: 
	// ]]] end generated region [Generated Methods]
	
	// [[[ begin generated region: do not modify [Generated Type Declarations]
public: 
	// ]]] end generated region [Generated Type Declarations]
	
	// [[[ begin generated region: do not modify [Generated Instance Variables]
private: 
	/**
	 * Label which shows the server's status messages.
	 */
	CEikLabel* iLabelStatus; 
	// ]]] end generated region [Generated Instance Variables]
	
	/**
	 * Shows if server has been started.
	 */
	TBool iIsServerStarted;
	
	// [[[ begin [Overridden Methods]
protected: 
	// ]]] end [Overridden Methods]
	
	
	// [[[ begin [User Handlers]
protected: 
	// ]]] end [User Handlers]
	
public: 
	enum TControls
		{
		// [[[ begin generated region: do not modify [Generated Contents]
		ELabelStatus,
		
		// ]]] end generated region [Generated Contents]
		
		// add any user-defined entries here...
		
		ELastControl
		};
	};
				
#endif // MAGICWANDSERVERCONTAINER_H
